﻿namespace TweetsharpAndAgFx
{
    using System;
    using System.Windows.Input;

    /// <summary>
    /// OpenWebBrowserCommand class.
    /// </summary>
    public class OpenWebBrowserCommand : ICommand
    {
        #region Events
        /// <summary>
        /// CanExecuteChanged event.
        /// </summary>
        public event EventHandler CanExecuteChanged;
        #endregion

        #region Public methods
        /// <summary>
        /// Indicates whether the command can be executed.
        /// </summary>
        /// <param name="parameter">Parameter is not used.</param>
        /// <returns>Always true.</returns>
        public bool CanExecute(object parameter)
        {
            return true;
        }

        /// <summary>
        /// Opens webbrowser using parameter as url.
        /// </summary>
        /// <param name="parameter">The Url to open.</param>
        public void Execute(object parameter)
        {
            if (!string.IsNullOrEmpty(parameter as string))
            {
                try
                {
                    var task = new Microsoft.Phone.Tasks.WebBrowserTask
                    {
                        Uri = new Uri(parameter as string, UriKind.Absolute)
                    };

                    task.Show();
                }
                catch
                {
                }
            }
        }
        #endregion
    }
}
