﻿namespace TweetsharpAndAgFx
{
    using AgFx;

    /// <summary>
    /// TweetLoadContext class.
    /// </summary>
    public class TwitterLoadContext : LoadContext
    {
        #region Constructor
        /// <summary>
        /// Initializes a new instance of the TwitterLoadContext class.
        /// </summary>
        /// <param name="twittername">The twitter name to load.</param>
        public TwitterLoadContext(string twittername)
            : base(twittername)
        {
        }
        #endregion

        #region Properties
        /// <summary>
        /// Gets the set Twitter name.
        /// </summary>
        public string TwitterName
        {
            get
            {
                return (string)this.Identity;
            }
        }
        #endregion
    }
}
